/*
 * このソースコードは blanco Frameworkにより自動生成されました。
 */
package blanco.filemanager.task.valueobject;

/**
 * 処理クラス [BlancoFileManagerImportProcess]の入力バリューオブジェクトクラスです。
 */
public class BlancoFileManagerImportProcessInput {
    /**
     * verboseモードで動作させるかどうか。
     *
     * フィールド: [verbose]。
     * デフォルト: [false]。
     */
    private boolean fVerbose = false;

    /**
     * 管理テーブルに取り込む対象となるファイルが含まれたディレクトリ。
     *
     * フィールド: [inputdir]。
     */
    private String fInputdir;

    /**
     * 管理上のプロジェクト名を指定します。multiprojectが指定された場合は、この指定は無効になります。
     *
     * フィールド: [projectname]。
     * デフォルト: [NONAME]。
     */
    private String fProjectname = "NONAME";

    /**
     * マルチプロジェクトかどうかを指定します。このパラメータを指定した場合は、projectname 名指定は無効になります。
     *
     * フィールド: [multiproject]。
     * デフォルト: [false]。
     */
    private boolean fMultiproject = false;

    /**
     * JDBC ドライバクラス名。\n例: org.apache.derby.jdbc.EmbeddedDriver
     *
     * フィールド: [jdbcdriver]。
     */
    private String fJdbcdriver;

    /**
     * JDBC 接続先 URL。\n例: jdbc:derby:tmp/derby.db;create=true
     *
     * フィールド: [jdbcurl]。
     */
    private String fJdbcurl;

    /**
     * JDBC 接続時のユーザー。\n例: user
     *
     * フィールド: [jdbcuser]。
     */
    private String fJdbcuser;

    /**
     * JDBC 接続時のパスワード。\n例: password
     *
     * フィールド: [jdbcpassword]。
     */
    private String fJdbcpassword;

    /**
     * フィールド [verbose] の値を設定します。
     *
     * フィールドの説明: [verboseモードで動作させるかどうか。]。
     *
     * @param argVerbose フィールド[verbose]に設定する値。
     */
    public void setVerbose(final boolean argVerbose) {
        fVerbose = argVerbose;
    }

    /**
     * フィールド [verbose] の値を取得します。
     *
     * フィールドの説明: [verboseモードで動作させるかどうか。]。
     * デフォルト: [false]。
     *
     * @return フィールド[verbose]から取得した値。
     */
    public boolean getVerbose() {
        return fVerbose;
    }

    /**
     * フィールド [inputdir] の値を設定します。
     *
     * フィールドの説明: [管理テーブルに取り込む対象となるファイルが含まれたディレクトリ。]。
     *
     * @param argInputdir フィールド[inputdir]に設定する値。
     */
    public void setInputdir(final String argInputdir) {
        fInputdir = argInputdir;
    }

    /**
     * フィールド [inputdir] の値を取得します。
     *
     * フィールドの説明: [管理テーブルに取り込む対象となるファイルが含まれたディレクトリ。]。
     *
     * @return フィールド[inputdir]から取得した値。
     */
    public String getInputdir() {
        return fInputdir;
    }

    /**
     * フィールド [projectname] の値を設定します。
     *
     * フィールドの説明: [管理上のプロジェクト名を指定します。multiprojectが指定された場合は、この指定は無効になります。]。
     *
     * @param argProjectname フィールド[projectname]に設定する値。
     */
    public void setProjectname(final String argProjectname) {
        fProjectname = argProjectname;
    }

    /**
     * フィールド [projectname] の値を取得します。
     *
     * フィールドの説明: [管理上のプロジェクト名を指定します。multiprojectが指定された場合は、この指定は無効になります。]。
     * デフォルト: [NONAME]。
     *
     * @return フィールド[projectname]から取得した値。
     */
    public String getProjectname() {
        return fProjectname;
    }

    /**
     * フィールド [multiproject] の値を設定します。
     *
     * フィールドの説明: [マルチプロジェクトかどうかを指定します。このパラメータを指定した場合は、projectname 名指定は無効になります。]。
     *
     * @param argMultiproject フィールド[multiproject]に設定する値。
     */
    public void setMultiproject(final boolean argMultiproject) {
        fMultiproject = argMultiproject;
    }

    /**
     * フィールド [multiproject] の値を取得します。
     *
     * フィールドの説明: [マルチプロジェクトかどうかを指定します。このパラメータを指定した場合は、projectname 名指定は無効になります。]。
     * デフォルト: [false]。
     *
     * @return フィールド[multiproject]から取得した値。
     */
    public boolean getMultiproject() {
        return fMultiproject;
    }

    /**
     * フィールド [jdbcdriver] の値を設定します。
     *
     * フィールドの説明: [JDBC ドライバクラス名。\n例: org.apache.derby.jdbc.EmbeddedDriver]。
     *
     * @param argJdbcdriver フィールド[jdbcdriver]に設定する値。
     */
    public void setJdbcdriver(final String argJdbcdriver) {
        fJdbcdriver = argJdbcdriver;
    }

    /**
     * フィールド [jdbcdriver] の値を取得します。
     *
     * フィールドの説明: [JDBC ドライバクラス名。\n例: org.apache.derby.jdbc.EmbeddedDriver]。
     *
     * @return フィールド[jdbcdriver]から取得した値。
     */
    public String getJdbcdriver() {
        return fJdbcdriver;
    }

    /**
     * フィールド [jdbcurl] の値を設定します。
     *
     * フィールドの説明: [JDBC 接続先 URL。\n例: jdbc:derby:tmp/derby.db;create=true]。
     *
     * @param argJdbcurl フィールド[jdbcurl]に設定する値。
     */
    public void setJdbcurl(final String argJdbcurl) {
        fJdbcurl = argJdbcurl;
    }

    /**
     * フィールド [jdbcurl] の値を取得します。
     *
     * フィールドの説明: [JDBC 接続先 URL。\n例: jdbc:derby:tmp/derby.db;create=true]。
     *
     * @return フィールド[jdbcurl]から取得した値。
     */
    public String getJdbcurl() {
        return fJdbcurl;
    }

    /**
     * フィールド [jdbcuser] の値を設定します。
     *
     * フィールドの説明: [JDBC 接続時のユーザー。\n例: user]。
     *
     * @param argJdbcuser フィールド[jdbcuser]に設定する値。
     */
    public void setJdbcuser(final String argJdbcuser) {
        fJdbcuser = argJdbcuser;
    }

    /**
     * フィールド [jdbcuser] の値を取得します。
     *
     * フィールドの説明: [JDBC 接続時のユーザー。\n例: user]。
     *
     * @return フィールド[jdbcuser]から取得した値。
     */
    public String getJdbcuser() {
        return fJdbcuser;
    }

    /**
     * フィールド [jdbcpassword] の値を設定します。
     *
     * フィールドの説明: [JDBC 接続時のパスワード。\n例: password]。
     *
     * @param argJdbcpassword フィールド[jdbcpassword]に設定する値。
     */
    public void setJdbcpassword(final String argJdbcpassword) {
        fJdbcpassword = argJdbcpassword;
    }

    /**
     * フィールド [jdbcpassword] の値を取得します。
     *
     * フィールドの説明: [JDBC 接続時のパスワード。\n例: password]。
     *
     * @return フィールド[jdbcpassword]から取得した値。
     */
    public String getJdbcpassword() {
        return fJdbcpassword;
    }

    /**
     * このバリューオブジェクトの文字列表現を取得します。
     *
     * <P>使用上の注意</P>
     * <UL>
     * <LI>オブジェクトのシャロー範囲のみ文字列化の処理対象となります。
     * <LI>オブジェクトが循環参照している場合には、このメソッドは使わないでください。
     * </UL>
     *
     * @return バリューオブジェクトの文字列表現。
     */
    @Override
    public String toString() {
        final StringBuffer buf = new StringBuffer();
        buf.append("blanco.filemanager.task.valueobject.BlancoFileManagerImportProcessInput[");
        buf.append("verbose=" + fVerbose);
        buf.append(",inputdir=" + fInputdir);
        buf.append(",projectname=" + fProjectname);
        buf.append(",multiproject=" + fMultiproject);
        buf.append(",jdbcdriver=" + fJdbcdriver);
        buf.append(",jdbcurl=" + fJdbcurl);
        buf.append(",jdbcuser=" + fJdbcuser);
        buf.append(",jdbcpassword=" + fJdbcpassword);
        buf.append("]");
        return buf.toString();
    }
}
